<html>
<head>
<title>OgreRenderTexture.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreRenderTexture.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreRenderTexture_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __RenderTexture_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __RenderTexture_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderTarget_8h.html">OgreRenderTarget.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre
<a name="l00036"></a>00036 {    
<a name="l00048"></a><a class="code" href="classOgre_1_1RenderTexture.html">00048</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1RenderTexture.html" title="This class represents a RenderTarget that renders to a Texture.">RenderTexture</a>: <span class="keyword">public</span> <a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a>
<a name="l00049"></a>00049     {
<a name="l00050"></a>00050     <span class="keyword">public</span>:
<a name="l00051"></a>00051         <a class="code" href="classOgre_1_1RenderTexture.html" title="This class represents a RenderTarget that renders to a Texture.">RenderTexture</a>(<a class="code" href="classOgre_1_1HardwarePixelBuffer.html" title="Specialisation of HardwareBuffer for a pixel buffer.">HardwarePixelBuffer</a> *buffer, <span class="keywordtype">size_t</span> zoffset);
<a name="l00052"></a>00052         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1RenderTexture.html" title="This class represents a RenderTarget that renders to a Texture.">RenderTexture</a>();
<a name="l00053"></a>00053 
<a name="l00054"></a>00054         <span class="keyword">virtual</span> <span class="keywordtype">void</span> copyContentsToMemory(<span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a> &amp;dst, <a class="code" href="classOgre_1_1RenderTarget.html#a4b42772d32712767391c749f4745397a">FrameBuffer</a> buffer);
<a name="l00055"></a>00055         <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> suggestPixelFormat() <span class="keyword">const</span>;
<a name="l00056"></a>00056 
<a name="l00057"></a>00057     <span class="keyword">protected</span>:
<a name="l00058"></a><a class="code" href="classOgre_1_1RenderTexture.html#a5f3d9fd4d3aa25751546d18144b77b6a">00058</a>         <a class="code" href="classOgre_1_1HardwarePixelBuffer.html" title="Specialisation of HardwareBuffer for a pixel buffer.">HardwarePixelBuffer</a> *<a class="code" href="classOgre_1_1RenderTexture.html#a5f3d9fd4d3aa25751546d18144b77b6a">mBuffer</a>;
<a name="l00059"></a><a class="code" href="classOgre_1_1RenderTexture.html#ad41ef4a560ac4f45b10eb56a87761347">00059</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1RenderTexture.html#ad41ef4a560ac4f45b10eb56a87761347">mZOffset</a>;
<a name="l00060"></a>00060     };
<a name="l00061"></a>00061 
<a name="l00069"></a><a class="code" href="classOgre_1_1MultiRenderTarget.html">00069</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1MultiRenderTarget.html" title="This class represents a render target that renders to multiple RenderTextures at once.">MultiRenderTarget</a>: <span class="keyword">public</span> <a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a>
<a name="l00070"></a>00070     {
<a name="l00071"></a>00071     <span class="keyword">public</span>:
<a name="l00072"></a>00072         <a class="code" href="classOgre_1_1MultiRenderTarget.html" title="This class represents a render target that renders to multiple RenderTextures at once.">MultiRenderTarget</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name);
<a name="l00073"></a>00073 
<a name="l00083"></a><a class="code" href="classOgre_1_1MultiRenderTarget.html#a75ea6438f29bd64dc86f4a6f2f284a41">00083</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> bindSurface(<span class="keywordtype">size_t</span> attachment, <a class="code" href="classOgre_1_1RenderTexture.html" title="This class represents a RenderTarget that renders to a Texture.">RenderTexture</a> *target)
<a name="l00084"></a>00084         {
<a name="l00085"></a>00085             <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> i = mBoundSurfaces.size(); i &lt;= attachment; ++i)
<a name="l00086"></a>00086             {
<a name="l00087"></a>00087                 mBoundSurfaces.push_back(0);
<a name="l00088"></a>00088             }
<a name="l00089"></a>00089             mBoundSurfaces[attachment] = target;
<a name="l00090"></a>00090 
<a name="l00091"></a>00091             bindSurfaceImpl(attachment, target);
<a name="l00092"></a>00092         }
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00099"></a><a class="code" href="classOgre_1_1MultiRenderTarget.html#acd7f368281eebf09a99369db73a6fc51">00099</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> unbindSurface(<span class="keywordtype">size_t</span> attachment)
<a name="l00100"></a>00100         {
<a name="l00101"></a>00101             <span class="keywordflow">if</span> (attachment &lt; mBoundSurfaces.size())
<a name="l00102"></a>00102                 mBoundSurfaces[attachment] = 0;
<a name="l00103"></a>00103             unbindSurfaceImpl(attachment);
<a name="l00104"></a>00104         }
<a name="l00105"></a>00105 
<a name="l00109"></a>00109         <span class="keyword">virtual</span> <span class="keywordtype">void</span> copyContentsToMemory(<span class="keyword">const</span> <a class="code" href="classOgre_1_1PixelBox.html" title="A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.">PixelBox</a> &amp;dst, FrameBuffer buffer);
<a name="l00110"></a>00110 
<a name="l00112"></a><a class="code" href="classOgre_1_1MultiRenderTarget.html#a4d03d1d91893cf22bb0ef09c8dc5334e">00112</a>         <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> <a class="code" href="classOgre_1_1MultiRenderTarget.html#a4d03d1d91893cf22bb0ef09c8dc5334e" title="Irrelevant implementation since cannot copy.">suggestPixelFormat</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="group__Image.html#gga7e0353e7d36d4c2e8468641b7303d39caa4292ed700edc51d74776f6efaf2a099" title="Unknown pixel format.">PF_UNKNOWN</a>; }
<a name="l00113"></a>00113 
<a name="l00114"></a><a class="code" href="classOgre_1_1MultiRenderTarget.html#ad1ea48cc62564b4f6729bbd13882af2b">00114</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;RenderTexture*&gt;::type</a> <a class="code" href="classOgre_1_1MultiRenderTarget.html#ad1ea48cc62564b4f6729bbd13882af2b">BoundSufaceList</a>;
<a name="l00116"></a><a class="code" href="classOgre_1_1MultiRenderTarget.html#a5e4e7c50d98f5fad6cd47273005b609d">00116</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1MultiRenderTarget.html#ad1ea48cc62564b4f6729bbd13882af2b">BoundSufaceList</a>&amp; <a class="code" href="classOgre_1_1MultiRenderTarget.html#a5e4e7c50d98f5fad6cd47273005b609d" title="Get a list of the surfaces which have been bound.">getBoundSurfaceList</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mBoundSurfaces; }
<a name="l00117"></a>00117 
<a name="l00119"></a><a class="code" href="classOgre_1_1MultiRenderTarget.html#a6cd9807732cc2ca84c31e7ddb76ab25d">00119</a>         <a class="code" href="classOgre_1_1RenderTexture.html" title="This class represents a RenderTarget that renders to a Texture.">RenderTexture</a>* getBoundSurface(<span class="keywordtype">size_t</span> index)
<a name="l00120"></a>00120         {
<a name="l00121"></a>00121             assert (index &lt; mBoundSurfaces.size());
<a name="l00122"></a>00122             <span class="keywordflow">return</span> mBoundSurfaces[index];
<a name="l00123"></a>00123         }
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 
<a name="l00126"></a>00126     <span class="keyword">protected</span>:
<a name="l00127"></a><a class="code" href="classOgre_1_1MultiRenderTarget.html#a183f9e1ce8d6a66bd7034ecc64239eea">00127</a>         <a class="code" href="classOgre_1_1MultiRenderTarget.html#ad1ea48cc62564b4f6729bbd13882af2b">BoundSufaceList</a> <a class="code" href="classOgre_1_1MultiRenderTarget.html#a183f9e1ce8d6a66bd7034ecc64239eea">mBoundSurfaces</a>;
<a name="l00128"></a>00128 
<a name="l00130"></a>00130         <span class="keyword">virtual</span> <span class="keywordtype">void</span> bindSurfaceImpl(<span class="keywordtype">size_t</span> attachment, <a class="code" href="classOgre_1_1RenderTexture.html" title="This class represents a RenderTarget that renders to a Texture.">RenderTexture</a> *target) = 0;
<a name="l00132"></a>00132         <span class="keyword">virtual</span> <span class="keywordtype">void</span> unbindSurfaceImpl(<span class="keywordtype">size_t</span> attachment) = 0;
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 
<a name="l00135"></a>00135     };
<a name="l00138"></a>00138 }
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
